Index: .hgsubstate
===================================================================
--- .hgsubstate	(revision 3564)
+++ .hgsubstate	(revision 3549)
@@ -1,1 +1,1 @@
-ebf44af6bda6b0c952a018917aab42d1d57b0921 inc/libs/clearbricks
+31cc764e47c0edb22866311ff1ad4484173b17f9 inc/libs/clearbricks
Index: CHANGELOG
===================================================================
--- CHANGELOG	(revision 3559)
+++ CHANGELOG	(revision 3485)
@@ -1,40 +1,2 @@
-Dotclear 2.12 - 2017-07-27
-===========================================================
-* 🛡 Security: Fix potential XSS
-* 🛡 Security: Enforce uniqness of the recovery key
-* 🛡 Security: Switch hash method from sha1 to sha512 (new installation only)
-* Two new values for base font size (37.5% and 87.5%)
-* Adaptive admin font size is now optional
-* Reduce base font size on very small devices
-* Refactor some functions to closures
-* No CSP directives in safe mode
-* Add current blog domain for script and style CSP directives
-* Backlinks:
-  * Retrieving ping URLs, let trackback first, then pingback, then finally webmention
-  * Get source post content to compose webmention excerpt and retrieve title
-  * Use source post title as blog name if this one is unknown (Anonymous blog is used if neither title nor blog name are known)
-* Datepicker's look refreshed
-* Allow 3rd party additional headers (URL handler)
-* Dublin core metadata removed
-* Using theme\<theme_name> namespace for _public.php and _prepend.php, in order to simplify theme copy and hack
-* Temporary password will have to be changed at first login (after resetting password)
-* Add ukrainian language
-* French help updated for theme editor
-* Add an option to disable Dotclear updates check (super-admin only)
-* Fix: Blogs’ admin (ie not super-admin) got back their blogs’ list but only super-admin may do actions
-* Fix: Post/page edition layout on different screen sizes
-* Fix: x-frame-options URL in admin
-* Fix: Cope with several copies of a same smiley in content
-* Fix: Allow 3rd party filters for template tags
-* Fix: Use getURLFor instead of old getBase function for breadcrumb
-* Fix: Give mysql/mysqli driver choice for DC 1.2 import
-* Clearbricks lib update from 0.9 to 1.0
-* jQuery lib update from 2.2.0 to 2.2.4 (last release of jQuery 2.n branch)
-* CKEditor lib update from 4.6.1 to 4.6.2
-* CodeMirror lib update from 5.15.3 to 5.25.1
-* 🐛 → Various bugs and typos fixed
-* 🌼 → Some locales and cosmetic adjustments
-* 📣 Warning: Next major release (2.13) will require PHP 5.5+
-
 Dotclear 2.11.2 - 2016-12-29
 ===========================================================
Index: admin/index.php
===================================================================
--- admin/index.php	(revision 3557)
+++ admin/index.php	(revision 3534)
@@ -71,10 +71,4 @@
 	}
 	$core->auth->user_prefs->dashboard->put('quickentry',false,'boolean');
-}
-if (!$core->auth->user_prefs->dashboard->prefExists('nodcupdate')) {
-	if (!$core->auth->user_prefs->dashboard->prefExists('nodcupdate',true)) {
-		$core->auth->user_prefs->dashboard->put('nodcupdate',false,'boolean','',null,true);
-	}
-	$core->auth->user_prefs->dashboard->put('nodcupdate',false,'boolean');
 }
 
@@ -212,5 +206,5 @@
 
 # Dotclear updates notifications
-if ($core->auth->isSuperAdmin() && !DC_NOT_UPDATE && is_readable(DC_DIGESTS) && !$core->auth->user_prefs->dashboard->nodcupdate)
+if ($core->auth->isSuperAdmin() && !DC_NOT_UPDATE && is_readable(DC_DIGESTS))
 {
 	$updater = new dcUpdate(DC_UPDATE_URL,'dotclear',DC_UPDATE_VERSION,DC_TPL_CACHE.'/versions');
@@ -237,6 +231,5 @@
 		if (version_compare(phpversion(),DC_NEXT_REQUIRED_PHP,'<')) {
 			echo '<p class="info">'.
-				sprintf(__('The next versions of Dotclear will not support PHP version < %s, your\'s is currently %s'),
-					DC_NEXT_REQUIRED_PHP,phpversion()).
+				sprintf(__('The next versions of Dotclear will not support PHP version < 5.5, your\'s is currently %s'),phpversion()).
 				'</p>';
 		}
Index: admin/install/check.php
===================================================================
--- admin/install/check.php	(revision 3565)
+++ admin/install/check.php	(revision 3137)
@@ -49,5 +49,5 @@
 	}
 
-	if ($con->driver() == 'mysql' || $con->driver() == 'mysqli' || $con->driver() == 'mysqlimb4')
+	if ($con->driver() == 'mysql' || $con->driver() == 'mysqli')
 	{
 		if (version_compare($con->version(),'4.1','<'))
Index: admin/install/index.php
===================================================================
--- admin/install/index.php	(revision 3557)
+++ admin/install/index.php	(revision 3432)
@@ -231,5 +231,4 @@
 		$core->auth->user_prefs->dashboard->put('dcnews',true,'boolean','',null,true);
 		$core->auth->user_prefs->dashboard->put('quickentry',true,'boolean','',null,true);
-		$core->auth->user_prefs->dashboard->put('nodcupdate',false,'boolean','',null,true);
 
 		# Add accessibility options
Index: admin/install/wizard.php
===================================================================
--- admin/install/wizard.php	(revision 3565)
+++ admin/install/wizard.php	(revision 3404)
@@ -201,5 +201,5 @@
 '<form action="wizard.php" method="post">'.
 '<p><label class="required" for="DBDRIVER"><abbr title="'.__('Required field').'">*</abbr> '.__('Database type:').'</label> '.
-    form::combo('DBDRIVER',array(__('MySQL (deprecated)')=>'mysql',__('MySQLi')=>'mysqli',__('MySQLi (full UTF-8)')=>'mysqlimb4',__('PostgreSQL')=>'pgsql',__('SQLite')=>'sqlite'),$DBDRIVER).'</p>'.
+    form::combo('DBDRIVER',array(__('MySQL (deprecated)')=>'mysql',__('MySQLi')=>'mysqli',__('PostgreSQL')=>'pgsql',__('SQLite')=>'sqlite'),$DBDRIVER).'</p>'.
 '<p><label for="DBHOST">'.__('Database Host Name:').'</label> '.
 form::field('DBHOST',30,255,html::escapeHTML($DBHOST)).'</p>'.
Index: admin/media.php
===================================================================
--- admin/media.php	(revision 3501)
+++ admin/media.php	(revision 3569)
@@ -392,5 +392,6 @@
 		'tmp_name' => $_FILES['upfile']['tmp_name'][0],
 		'error' => $_FILES['upfile']['error'][0],
-		'size' => $_FILES['upfile']['size'][0]
+		'size' => $_FILES['upfile']['size'][0],
+		'title' => html::escapeHTML($_FILES['upfile']['name'][0])
 		);
 
@@ -401,5 +402,5 @@
 		try {
 			files::uploadStatus($upfile);
-			$new_file_id = $core->media->uploadFile($upfile['tmp_name'], $upfile['name']);
+			$new_file_id = $core->media->uploadFile($upfile['tmp_name'],$upfile['name'],$upfile['title']);
 
 			$message['files'][] = array(
Index: admin/preferences.php
===================================================================
--- admin/preferences.php	(revision 3566)
+++ admin/preferences.php	(revision 3499)
@@ -36,7 +36,4 @@
 $user_dm_quickentry = $core->auth->user_prefs->dashboard->quickentry;
 $user_dm_nofavicons = $core->auth->user_prefs->dashboard->nofavicons;
-if ($core->auth->isSuperAdmin()) {
-	$user_dm_nodcupdate = $core->auth->user_prefs->dashboard->nodcupdate;
-}
 
 $core->auth->user_prefs->addWorkspace('accessibility');
@@ -46,5 +43,4 @@
 $user_ui_enhanceduploader = $core->auth->user_prefs->interface->enhanceduploader;
 $user_ui_hidemoreinfo = $core->auth->user_prefs->interface->hidemoreinfo;
-$user_ui_hidehelpbutton = $core->auth->user_prefs->interface->hidehelpbutton;
 $user_ui_htmlfontsize = $core->auth->user_prefs->interface->htmlfontsize;
 $user_ui_dynfontsize = $core->auth->user_prefs->interface->dynfontsize;
@@ -246,5 +242,4 @@
 		$core->auth->user_prefs->interface->put('enhanceduploader',!empty($_POST['user_ui_enhanceduploader']),'boolean');
 		$core->auth->user_prefs->interface->put('hidemoreinfo',!empty($_POST['user_ui_hidemoreinfo']),'boolean');
-		$core->auth->user_prefs->interface->put('hidehelpbutton',!empty($_POST['user_ui_hidehelpbutton']),'boolean');
 		$core->auth->user_prefs->interface->put('htmlfontsize',$_POST['user_ui_htmlfontsize'],'string');
 		$core->auth->user_prefs->interface->put('dynfontsize',!empty($_POST['user_ui_dynfontsize']),'boolean');
@@ -305,7 +300,4 @@
 		$core->auth->user_prefs->dashboard->put('quickentry',!empty($_POST['user_dm_quickentry']),'boolean');
 		$core->auth->user_prefs->dashboard->put('nofavicons',empty($_POST['user_dm_nofavicons']),'boolean');
-		if ($core->auth->isSuperAdmin()) {
-			$core->auth->user_prefs->dashboard->put('nodcupdate',!empty($_POST['user_dm_nodcupdate']),'boolean');
-		}
 		$core->auth->user_prefs->interface->put('iconset',(!empty($_POST['user_ui_iconset']) ? $_POST['user_ui_iconset'] : ''));
 		$core->auth->user_prefs->interface->put('nofavmenu',empty($_POST['user_ui_nofavmenu']),'boolean');
@@ -526,8 +518,4 @@
 __('Hide all secondary information and notes').'</label></p>'.
 
-'<p><label for="user_ui_hidehelpbutton" class="classic">'.
-form::checkbox('user_ui_hidehelpbutton',1,$user_ui_hidehelpbutton).' '.
-__('Hide help button').'</label></p>'.
-
 '<p><label for="user_ui_htmlfontsize" class="classic">'.__('Font size:').'</label>'.' '.
 form::combo('user_ui_htmlfontsize',$htmlfontsize_combo,$user_ui_htmlfontsize).'</p>'.
@@ -770,13 +758,6 @@
 '<p><label for="user_dm_quickentry" class="classic">'.
 form::checkbox('user_dm_quickentry',1,$user_dm_quickentry).' '.
-__('Display quick entry form').'</label></p>';
-
-if ($core->auth->isSuperAdmin()) {
-	echo
-	'<p><label for="user_dm_nodcupdate" class="classic">'.
-	form::checkbox('user_dm_nodcupdate',1,$user_dm_nodcupdate).' '.
-	__('Do not display Dotclear updates').'</label></p>';
-}
-
+__('Display quick entry form').'</label><br class="clear" />'. //Opera sucks
+'</p>';
 echo '</div>';
 
Index: inc/admin/lib.dc.page.php
===================================================================
--- inc/admin/lib.dc.page.php	(revision 3566)
+++ inc/admin/lib.dc.page.php	(revision 3509)
@@ -352,9 +352,7 @@
 
 		if (!$GLOBALS['__resources']['ctxhelp']) {
-			if (!$core->auth->user_prefs->interface->hidehelpbutton) {
-				echo
-				'<p id="help-button"><a href="'.$core->adminurl->get("admin.help").'" class="outgoing" title="'.
-				__('Global help').'">'.__('Global help').'</a></p>';
-			}
+			echo
+			'<p id="help-button"><a href="'.$core->adminurl->get("admin.help").'" class="outgoing" title="'.
+			__('Global help').'">'.__('Global help').'</a></p>';
 		}
 
@@ -598,10 +596,6 @@
 	{
 		global $core;
-
-		if ($core->auth->user_prefs->interface->hidehelpbutton) {
-			return;
-		}
-
 		$args = func_get_args();
+
 		$args = new ArrayObject($args);
 
Index: inc/config.php.in
===================================================================
--- inc/config.php.in	(revision 3565)
+++ inc/config.php.in	(revision 3533)
@@ -12,5 +12,5 @@
 if (!defined('DC_RC_PATH')) { return; }
 
-// Database driver (mysql (deprecated, disabled in PHP7), mysqli, mysqlimb4 (full UTF-8), pgsql, sqlite)
+// Database driver (mysql (deprecated, disabled in PHP7), mysqli, pgsql, sqlite)
 define('DC_DBDRIVER','');
 
Index: inc/core/class.dc.blog.php
===================================================================
--- inc/core/class.dc.blog.php	(revision 3565)
+++ inc/core/class.dc.blog.php	(revision 3423)
@@ -694,5 +694,5 @@
 		if (!$rs->isEmpty())
 		{
-			if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli' || $this->con->driver() == 'mysqlimb4') {
+			if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli') {
 				$clause = "REGEXP '^".$this->con->escape($url)."[0-9]+$'";
 			} elseif ($this->con->driver() == 'pgsql') {
@@ -1939,5 +1939,5 @@
 		if (!$rs->isEmpty())
 		{
-			if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli' || $this->con->driver() == 'mysqlimb4') {
+			if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli') {
 				$clause = "REGEXP '^".$this->con->escape($url)."[0-9]+$'";
 			} elseif ($this->con->driver() == 'pgsql') {
Index: inc/core/class.dc.core.php
===================================================================
--- inc/core/class.dc.core.php	(revision 3565)
+++ inc/core/class.dc.core.php	(revision 3402)
@@ -72,6 +72,4 @@
 		} elseif ($this->con instanceof mysqliConnection) {
 			mysqliConnection::$weak_locks = true;
-		} elseif ($this->con instanceof mysqlimb4Connection) {
-			mysqlimb4Connection::$weak_locks = true;
 		}
 
Index: inc/prepend.php
===================================================================
--- inc/prepend.php	(revision 3563)
+++ inc/prepend.php	(revision 3546)
@@ -144,5 +144,5 @@
 # Constants
 define('DC_ROOT',path::real(dirname(__FILE__).'/..'));
-define('DC_VERSION','2.13-dev');
+define('DC_VERSION','2.12-dev');
 define('DC_DIGESTS',dirname(__FILE__).'/digests');
 define('DC_L10N_ROOT',dirname(__FILE__).'/../locales');
@@ -151,8 +151,9 @@
 define('DC_DISTRIB_THEMES','berlin,blueSilence,blowupConfig,customCSS,default,ductile');
 define('DC_DEFAULT_TPLSET','mustek');
-define('DC_DEFAULT_JQUERY','2.2.4');
+define('DC_DEFAULT_JQUERY','1.4.2');
 
 if (!defined('DC_NEXT_REQUIRED_PHP')) {
-	define('DC_NEXT_REQUIRED_PHP','5.5');	// Announced in 2.12, will be required in 2.13
+//	define('DC_NEXT_REQUIRED_PHP','5.5');	// Announced in 2.12, will be required in 2.13
+	define('DC_NEXT_REQUIRED_PHP','5.3');
 }
 
Index: inc/public/lib.tpl.context.php
===================================================================
--- inc/public/lib.tpl.context.php	(revision 3567)
+++ inc/public/lib.tpl.context.php	(revision 3507)
@@ -122,7 +122,10 @@
 	}
 
-	public static function global_filters($str,$args,$tag='')
-	{
-		$args[0] = &$str;
+	public static function global_filters($str,$_args,$tag='')
+	{
+		$_args[0] = &$str;
+
+		# Terrible hack to pass args values by reference
+		$args = new ArrayObject($_args);
 
 		# --BEHAVIOR-- publicBeforeContentFilter
Index: plugins/importExport/inc/class.dc.import.dc1.php
===================================================================
--- plugins/importExport/inc/class.dc.import.dc1.php	(revision 3551)
+++ plugins/importExport/inc/class.dc.import.dc1.php	(revision 2566)
@@ -29,5 +29,4 @@
 	protected $vars;
 	protected $base_vars = array(
-		'db_driver' => 'mysql',
 		'db_host' => '',
 		'db_name' => '',
@@ -80,5 +79,4 @@
 		{
 			case 'step1':
-				$this->vars['db_driver'] = $_POST['db_driver'];
 				$this->vars['db_host'] = $_POST['db_host'];
 				$this->vars['db_name'] = $_POST['db_name'];
@@ -141,10 +139,4 @@
 		}
 
-		# db drivers
-		$db_drivers = array(
-			'mysql' => 'mysql',
-			'mysqli' => 'mysqli'
-		);
-
 		switch ($this->step)
 		{
@@ -158,6 +150,4 @@
 				printf($this->imForm(1,__('General information'),__('Import my blog now')),
 				'<p>'.__('We first need some information about your old Dotclear 1.2 installation.').'</p>'.
-				'<p><label for="db_driver">'.__('Database driver (must be mysqli if PHP 7 or higher):').'</label> '.
-				form::combo('db_driver',$db_drivers,html::escapeHTML($this->vars['db_driver'])).'</p>'.
 				'<p><label for="db_host">'.__('Database Host Name:').'</label> '.
 				form::field('db_host',30,255,html::escapeHTML($this->vars['db_host'])).'</p>'.
@@ -245,5 +235,5 @@
 	protected function db()
 	{
-		$db = dbLayer::init($this->vars['db_driver'],$this->vars['db_host'],$this->vars['db_name'],$this->vars['db_user'],$this->vars['db_pwd']);
+		$db = dbLayer::init('mysql',$this->vars['db_host'],$this->vars['db_name'],$this->vars['db_user'],$this->vars['db_pwd']);
 
 		$rs = $db->select("SHOW TABLES LIKE '".$this->vars['db_prefix']."%'");
Index: plugins/importExport/inc/flat/class.flat.import.php
===================================================================
--- plugins/importExport/inc/flat/class.flat.import.php	(revision 3565)
+++ plugins/importExport/inc/flat/class.flat.import.php	(revision 3323)
@@ -164,5 +164,5 @@
 					if (in_array($last_line_name,$constrained)) {
 						# UNDEFER
-						if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli' || $this->con->driver() == 'mysqlimb4') $this->con->execute('SET foreign_key_checks = 1');
+						if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli') $this->con->execute('SET foreign_key_checks = 1');
 						if ($this->con->driver() == 'pgsql') $this->con->execute('SET CONSTRAINTS ALL DEFERRED');
 					}
@@ -170,5 +170,5 @@
 					if (in_array($line->__name,$constrained)) {
 						# DEFER
-						if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli' || $this->con->driver() == 'mysqlimb4') $this->con->execute('SET foreign_key_checks = 0');
+						if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli') $this->con->execute('SET foreign_key_checks = 0');
 						if ($this->con->driver() == 'pgsql') $this->con->execute('SET CONSTRAINTS ALL IMMEDIATE');
 					}
@@ -209,5 +209,5 @@
 			}
 
-			if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli' || $this->con->driver() == 'mysqlimb4') $this->con->execute('SET foreign_key_checks = 1');
+			if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli') $this->con->execute('SET foreign_key_checks = 1');
 			if ($this->con->driver() == 'pgsql') $this->con->execute('SET CONSTRAINTS ALL DEFERRED');
 		}
